/////////////////////////////////////////////////////////////////////////////////////
//
//  ,       ++, ѹ  http://www.interestprograms.ru
//
/////////////////////////////////////////////////////////////////////////////////////



// TransDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TransApp.h"
#include "TransDlg.h"
#include ".\transdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnNMClickSyslink1(NMHDR* pNMHDR, LRESULT* pResult);
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_NOTIFY(NM_CLICK, IDC_SYSLINK1, &CAboutDlg::OnNMClickSyslink1)
END_MESSAGE_MAP()


// CTransDlg dialog



CTransDlg::CTransDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTransDlg::IDD, pParent),
	m_Page_X(0),
	m_Page_Y(0),
	m_SizePage_X(0),
	m_SizePage_Y(0)
	
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
	
}

void CTransDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_HELP, m_StatiicHelp);
}

BEGIN_MESSAGE_MAP(CTransDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_TRANS_50hertz, OnTrans50hertz)
	ON_COMMAND(ID_PULSE, OnPulse)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_ABOUTTRANS, OnAbouttrans)
END_MESSAGE_MAP()


// CTransDlg message handlers

BOOL CTransDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_wndTrans50hertz.Create(IDD_DIALOG_TRANS50HERTZ, this);
	m_wndTransPulse.Create(IDD_DIALOG_PULSE, this);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTransDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTransDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTransDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTransDlg::OnTrans50hertz()
{
	SetWindowText("   (~50  )");
	m_wndTrans50hertz.ShowWindow(SW_SHOW);
	m_wndTransPulse.ShowWindow(SW_HIDE);
}

void CTransDlg::OnPulse()
{
	SetWindowText("  ");
	m_wndTransPulse.ShowWindow(SW_SHOW);
	m_wndTrans50hertz.ShowWindow(SW_HIDE);
}

void CTransDlg::OnExit()
{
	// TODO: Add your command handler code here
	this->DestroyWindow();
}



void CTransDlg::OnFilePrint()
{
	if (m_wndTrans50hertz.IsWindowVisible() == false &&
		m_wndTransPulse.IsWindowVisible() == false)
	{
		AfxMessageBox(" !");
		return;
	}

	HDC     hDC;
    DOCINFO di;
							
    // Create a device context for the
    // printer to which text will be output.
	CPrintDialog dlgPD(TRUE);


	//***************************************
	//   
	PRINTDLG pd;
	if(AfxGetApp()->GetPrinterDeviceDefaults(&pd) == true)
	{
		DEVMODE* dm = (DEVMODE*)LocalLock(pd.hDevMode);
		dm->dmFields = DM_ORIENTATION | DM_PAPERSIZE;
		dm->dmOrientation = DMORIENT_PORTRAIT;
		dm->dmPaperSize = DMPAPER_A4;

		dlgPD.m_pd.hDevMode = pd.hDevMode;
		LocalUnlock(pd.hDevMode);
	}
	else
	{
		AfxMessageBox(",     .");
		return;
	}


	//***************************************
	//   
	if (dlgPD.DoModal() == IDOK)
	{
		//......................................                       
		hDC = dlgPD.CreatePrinterDC();

		// Setup the DOCINFO structure.
		//.............................
		memset(&di, 0, sizeof(DOCINFO));
		di.cbSize = sizeof(DOCINFO);
		di.lpszDocName = "Transformer";

		CDC dc;
		dc.Attach(hDC);
		// Start the printing.
		//....................
		dc.SetMapMode(MM_LOMETRIC);
		if (StartDoc(dc.GetSafeHdc(), &di) != SP_ERROR)
		{
			// Print page 1.
			//..............
			StartPage(dc.GetSafeHdc());

			if (m_wndTrans50hertz.IsWindowVisible() == true)
				PrintTranse50hertz(&dc);

			if (m_wndTransPulse.IsWindowVisible() == true)
				PrintTransPulse(&dc);

			EndPage(dc.GetSafeHdc());


			/*
			// Print page 2.
			//..............
			StartPage( hDC );
			TextOut( hDC, 10, 10, "This is on Page 2.",18);
			EndPage( hDC );
			// End printing.
			//..............
			*/
			EndDoc(dc.GetSafeHdc());
		}


		dc.Detach();
		DeleteDC(hDC);
	}
}

void CTransDlg::PrintTranse50hertz(CDC* pDC)
{
	m_Page_X = 100;
	m_SizePage_X = 2090;
	m_Page_Y = -50;
	int HeightStr = 45;
	//
	CFont font, *oldFont;
	font.CreatePointFont(180, "Arial");
	oldFont = pDC->SelectObject(&font);
	pDC->DrawText("    TransK", CRect(m_Page_X, m_Page_Y+30, m_SizePage_X, m_Page_Y-HeightStr), DT_LEFT); 
	font.DeleteObject();
	font.CreatePointFont(300, "Times New Roman");
	pDC->SelectObject(&font);
	pDC->DrawText("    ~50", CRect(m_Page_X, m_Page_Y, m_SizePage_X, m_Page_Y-HeightStr), DT_CENTER); 

	// 
	{
	m_Page_Y -= 60;// 
	CString strPower, str;
	m_wndTrans50hertz.GetDlgItem(IDC_STATIC_P)->GetWindowText(strPower);
	str = "  - ";
	str += strPower;
	str += " ";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr, m_SizePage_X, m_Page_Y-HeightStr*2), DT_LEFT);
	}

	// 
	{
	CString strIron, str;
	m_wndTrans50hertz.GetDlgItem(IDC_STATIC_IRON)->GetWindowText(strIron);
	str = "    - ";
	str += strIron;
	str += " .";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr*2, m_SizePage_X, m_Page_Y-HeightStr*3), DT_LEFT);
	}

	////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////
	// 
	{
	m_Page_Y -= 60;// 
	pDC->DrawText(" ", CRect(10, m_Page_Y-HeightStr*3, m_SizePage_X, m_Page_Y-HeightStr*4), DT_CENTER);
	CString strVPower, str;
	m_wndTrans50hertz.GetDlgItem(IDC_EDIT_PV1)->GetWindowText(strVPower);
	str = "  - ";
	str += strVPower;
	str += "";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr*4, m_SizePage_X, m_Page_Y-HeightStr*5), DT_LEFT);
	}
	// 
	// 
	{
	//m_Page_Y -= 60;// 
	//pDC->DrawText(" ", CRect(10, m_Page_Y-HeightStr*3, m_SizePage_X, m_Page_Y-HeightStr*4), DT_CENTER);
	CString strCount, str;
	m_wndTrans50hertz.GetDlgItem(IDC_STATIC_PC0)->GetWindowText(strCount);
	str = "  - ";
	str += strCount;
	str += " ";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr*5, m_SizePage_X, m_Page_Y-HeightStr*6), DT_LEFT);
	}
	// 
	{
	CString strDiam, str;
	m_wndTrans50hertz.GetDlgItem(IDC_STATIC_PD0)->GetWindowText(strDiam);
	str = " / - ";
	str += strDiam;
	str += " /.";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr*6, m_SizePage_X, m_Page_Y-HeightStr*7), DT_LEFT);
	}
	
	//  

	
	//////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////
	{
	m_Page_Y -= 60;// 
	pDC->DrawText(" ", CRect(m_Page_X, m_Page_Y-HeightStr*7, m_SizePage_X, m_Page_Y-HeightStr*8), DT_CENTER);
	}
	int t=7, t1=0, t2=0, t3=0;
	int count = 1;
	for(int i = 0; i < 12; i++){
		CString str;
		m_wndTrans50hertz.m_StaticOut_SC[i].GetWindowText(str);
		if(str != "#####"){
			CString s, s1;
			s1.Format("%d", count++);
			s = " ";
			s += s1;
			t += 1, t1 = t+1, t2 = t1+1, t3 = t2+1;
			pDC->DrawText(s, CRect(m_Page_X, m_Page_Y-HeightStr*(t), m_SizePage_X, m_Page_Y-HeightStr*(t+1)), DT_LEFT);
		
			//   
			CString sV, strwndV;
			sV = "   - ";
			m_wndTrans50hertz.m_EditS_V[i].GetWindowText(strwndV);
			sV += strwndV;
			sV += " ";
			pDC->DrawText(sV, CRect(m_Page_X+100, m_Page_Y-HeightStr*(t1), m_SizePage_X, m_Page_Y-HeightStr*(t1+1)), DT_LEFT);
		
			//    
			CString sA, strwndA;
			sA = "    - ";
			m_wndTrans50hertz.m_EditS_A[i].GetWindowText(strwndA);
			sA += strwndA;
			sA += " ";
			pDC->DrawText(sA, CRect(m_Page_X+700, m_Page_Y-HeightStr*(t1), m_SizePage_X, m_Page_Y-HeightStr*(t1+1)), DT_LEFT);


			// 
			s = "  - ";
			s += str;
			pDC->DrawText(s, CRect(m_Page_X+100, m_Page_Y-HeightStr*(t2), m_SizePage_X, m_Page_Y-HeightStr*(t2+1)), DT_LEFT);
			

			//   
			m_wndTrans50hertz.m_StaticOut_SD[i].GetWindowText(str);
			s = "/  - ";
			s += str;
			s += " /.";
			pDC->DrawText(s, CRect(m_Page_X+100, m_Page_Y-HeightStr*(t3), m_SizePage_X, m_Page_Y-HeightStr*(t3+1)), DT_LEFT);
			t = t3;
		}
		
	}

	//////////////////////////////////////////////////////////////////////////////////////
	pDC->SelectObject(oldFont);

	
}

void CTransDlg::PrintTransPulse(CDC* pDC)
{
	m_Page_X = 100;
	m_SizePage_X = 2090;
	m_Page_Y = -50;
	int HeightStr = 45;
	//
	CFont font, *oldFont;
	font.CreatePointFont(180, "Arial");
	oldFont = pDC->SelectObject(&font);
	pDC->DrawText("    TransK", CRect(m_Page_X, m_Page_Y+30, m_SizePage_X, m_Page_Y-HeightStr), DT_LEFT); 
	font.DeleteObject();
	font.CreatePointFont(300, "Times New Roman");
	pDC->SelectObject(&font);
	pDC->DrawText("   ", CRect(m_Page_X, m_Page_Y, m_SizePage_X, m_Page_Y-HeightStr), DT_CENTER); 

	////////////////////////////////////////////////////////////////////////////
	// 
	////////////////////////////////////////////////////////////////////////////
	
	m_Page_Y -= 40;// 
	pDC->DrawText(" ", CRect(m_Page_X, m_Page_Y-HeightStr, m_SizePage_X, m_Page_Y-HeightStr*2), DT_CENTER);

	//   //Frequency of the voltage of the feeding
	{
	CString strFreq, str;
	m_wndTransPulse.GetDlgItem(IDC_EDIT_FREQ)->GetWindowText(strFreq);
	str = "   - ";
	str += strFreq;
	str += " ";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr*2, m_SizePage_X, m_Page_Y-HeightStr*3), DT_LEFT);
	}
	//   -  
	{
	CString strV_KE, str;
	m_wndTransPulse.GetDlgItem(IDC_EDIT_KE)->GetWindowText(strV_KE);
	str = "  -  - ";
	str += strV_KE;
	str += " ";
	pDC->DrawText(str, CRect(m_Page_X, m_Page_Y-HeightStr*3, m_SizePage_X, m_Page_Y-HeightStr*4), DT_LEFT);
	}
	//---------------------------------------------
	{
	CString strTesla, s;
	strTesla = "( )    - ";
	m_wndTransPulse.GetDlgItem(IDC_EDIT_TESLA)->GetWindowText(s);
	strTesla += s;
	strTesla += " T";
	pDC->DrawText(strTesla, CRect(m_Page_X, m_Page_Y-HeightStr*4, m_SizePage_X, m_Page_Y-HeightStr*5), DT_LEFT);
	CString strOutwardDiam, strInwardDiam, strHeight,  str;
	m_wndTransPulse.GetDlgItem(IDC_EDIT_OUTWARDDIAM)->GetWindowText(strOutwardDiam);
	m_wndTransPulse.GetDlgItem(IDC_EDIT_INWARDDIAM)->GetWindowText(strInwardDiam);
	m_wndTransPulse.GetDlgItem(IDC_EDIT_HEIGHT)->GetWindowText(strHeight);
	str = "  -   ";
	str += strOutwardDiam;
	str += " ,   ";
	str += strInwardDiam;
	str += " ,  ";
	str += strHeight;
	str += " ";
	pDC->DrawText(str, CRect(m_Page_X+50, m_Page_Y-HeightStr*5, m_SizePage_X, m_Page_Y-HeightStr*6), DT_LEFT);
	//   
	CString strGabPower, sGab, sUsingPower;
	strGabPower = "  - ";
	m_wndTransPulse.GetDlgItem(IDC_STATIC_PGAB)->GetWindowText(sGab);
	m_wndTransPulse.GetDlgItem(IDC_STATIC_P)->GetWindowText(sUsingPower);
	float gabPower = atof(sGab), usingPower = atof(sUsingPower); 
	strGabPower += sGab;
	strGabPower += " ";
	if(gabPower > usingPower){
		strGabPower += " > ";
		strGabPower += "   - ";
		strGabPower += sUsingPower;
		strGabPower += " ";
		pDC->DrawText("  !", CRect(m_Page_X+50, m_Page_Y-HeightStr*6, m_SizePage_X, m_Page_Y-HeightStr*7), DT_CENTER);
	}
	else{
		strGabPower += " < ";
		strGabPower += "   - ";
		strGabPower += sUsingPower;
		strGabPower += " ";
		pDC->DrawText("!   !", CRect(m_Page_X+50, m_Page_Y-HeightStr*6, m_SizePage_X, m_Page_Y-HeightStr*7), DT_CENTER);
	}
	pDC->DrawText(strGabPower, CRect(m_Page_X+50, m_Page_Y-HeightStr*7, m_SizePage_X, m_Page_Y-HeightStr*8), DT_LEFT);
	}

	//  

	/////////////////////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////////////////////
	{
	m_Page_Y -= 40;// 
	pDC->DrawText(" ", CRect(m_Page_X, m_Page_Y-HeightStr*8, m_SizePage_X, m_Page_Y-HeightStr*9), DT_CENTER);
	}
	int t=8, t1=0, t2=0, t3=0;
	int count = 1;
	for(int i = 0; i < 12; i++){
		CString str;
		m_wndTransPulse.m_StaticOut_SC[i].GetWindowText(str);
		if(str != "#####"){
			CString s, s1;
			s1.Format("%d", count++);
			s = " ";
			s += s1;
			t += 1, t1 = t+1, t2 = t1+1, t3 = t2+1;
			pDC->DrawText(s, CRect(m_Page_X, m_Page_Y-HeightStr*(t), m_SizePage_X, m_Page_Y-HeightStr*(t+1)), DT_LEFT);
		
			//   
			CString sV, strwndV;
			sV = "   - ";
			m_wndTransPulse.m_EditS_V[i].GetWindowText(strwndV);
			sV += strwndV;
			sV += " ";
			pDC->DrawText(sV, CRect(m_Page_X+100, m_Page_Y-HeightStr*(t1), m_SizePage_X, m_Page_Y-HeightStr*(t1+1)), DT_LEFT);
		
			//    
			CString sA, strwndA;
			sA = "    - ";
			m_wndTransPulse.m_EditS_A[i].GetWindowText(strwndA);
			sA += strwndA;
			sA += " ";
			pDC->DrawText(sA, CRect(m_Page_X+700, m_Page_Y-HeightStr*(t1), m_SizePage_X, m_Page_Y-HeightStr*(t1+1)), DT_LEFT);


			// 
			s = "  - ";
			s += str;
			pDC->DrawText(s, CRect(m_Page_X+100, m_Page_Y-HeightStr*(t2), m_SizePage_X, m_Page_Y-HeightStr*(t2+1)), DT_LEFT);
			

			//   
			m_wndTransPulse.m_StaticOut_SD[i].GetWindowText(str);
			s = "/  - ";
			s += str;
			s += " /.";
			pDC->DrawText(s, CRect(m_Page_X+100, m_Page_Y-HeightStr*(t3), m_SizePage_X, m_Page_Y-HeightStr*(t3+1)), DT_LEFT);
			t = t3;
		}
		
	}

	//   

	pDC->SelectObject(oldFont);
}

void CTransDlg::OnAbouttrans()
{
	// TODO: Add your command handler code here
	CAboutDlg dlg;
	dlg.DoModal();
}


void CAboutDlg::OnNMClickSyslink1(NMHDR* pNMHDR, LRESULT* pResult)
{
	// TODO:     
	*pResult = 0;

	ShellExecute(NULL, "open", "https://www.interestprograms.ru", NULL, NULL, SW_SHOW);
}
