// TransDlg.h : header file
//

#pragma once
#include "trans50hertz.h"
#include "transpulse.h"
#include "afxwin.h"


// CTransDlg dialog
class CTransDlg : public CDialog
{
// Construction
public:
	CTransDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_TRANS_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CTrans50hertz m_wndTrans50hertz;
	CTransPulse m_wndTransPulse;
	afx_msg void OnTrans50hertz();
	afx_msg void OnPulse();
	CStatic m_StatiicHelp;

public:
	afx_msg void OnExit();
	afx_msg void OnFilePrint();
	void PrintTranse50hertz(CDC* pDC);
	void PrintTransPulse(CDC* pDC);
	int m_Page_X, m_SizePage_X;
	int m_Page_Y, m_SizePage_Y;
	afx_msg void OnAbouttrans();
};
